
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <tchar.h>
#include <Msctf.h>
#pragma comment(lib, "imm32.lib")

#include "usermsg.h"

__declspec(dllexport) void CALLBACK sethook(HWND, TF_INPUTPROCESSORPROFILE **);
__declspec(dllexport) void CALLBACK freehook();
__declspec(dllexport) void CALLBACK getprev(DWORD, DWORD, HKL);

#pragma comment(linker, "/section:.sharedata,rws")
#pragma data_seg(".sharedata")
HHOOK hHookWnd = 0;
HWND hWnd = 0;
HWND hWnd_1 = 0;
DWORD toDo = 0, cMode = 0;
HKL hKL = 0;
TF_INPUTPROCESSORPROFILE profile = {};
#pragma data_seg()

HINSTANCE hdll;

BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD reason, LPVOID lpReserved)
{
    if (reason == DLL_PROCESS_ATTACH){
        hdll = hInstance;
    }
    return TRUE;
}

LRESULT CALLBACK CallWndProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	if (nCode != HC_ACTION){
		return CallNextHookEx(hHookWnd, nCode, wParam, lParam);
	}

	CWPSTRUCT *p = (CWPSTRUCT *)lParam;

	//gȂbZ[W͑߂ɏ
	if (!(
			p->message == WM_IME_SETCONTEXT ||
			p->message == WM_IME_NOTIFY ||
			p->message == WM_SETFOCUS ||
			p->message == WM_INPUTLANGCHANGE
		)){
		return CallNextHookEx(hHookWnd, nCode, wParam, lParam);
	}
	//ςȖ[v & ւWM_SETFOCUSLȂ
	if (p->hwnd == hWnd){
		return CallNextHookEx(hHookWnd, nCode, wParam, lParam);
	}

	//܂ŗ͔̂rIAP[XȂ̂ŁAȍ~x͂܂CɂȂĂ

	TCHAR className[256];
	//tH[JX𓾂EBhELĂ
	if (p->message == WM_SETFOCUS){
		GetClassName(p->hwnd, className, sizeof className);
		if (lstrcmp(className, _T("Shell_TrayWnd")) == 0 || lstrcmp(className, _T("MSCTFIME UI")) == 0){
			return CallNextHookEx(hHookWnd, nCode, wParam, lParam);
		}
		GetClassName(p->hwnd, className, sizeof className);
		hWnd_1 = p->hwnd;
		return CallNextHookEx(hHookWnd, nCode, wParam, lParam);
	}
	
/*	//leave
	if (p->message == WM_IME_NOTIFY && p->wParam == IMN_CLOSESTATUSWINDOW){
		PostMessage(hWnd, WM_USERNOTIFY, _IME_CLOSESTATUSWINDOW, 0);
		return CallNextHookEx(hHookWnd, nCode, wParam, lParam);
	}*/

	//EBhE؂ւ
	bool b1 = p->message == WM_IME_SETCONTEXT && p->wParam && p->lParam == ISC_SHOWUIALL;
	//IMEJ/
	bool b2 = p->message == WM_IME_NOTIFY && p->wParam == IMN_SETOPENSTATUS;
	//IME̕ϊ[h
	bool b3 = p->message == WM_IME_NOTIFY && p->wParam == IMN_SETCONVERSIONMODE;
	//؂ւ
	bool b4 = p->message == WM_INPUTLANGCHANGE;
	if (!(b1 || b2 || b3 || b4)){
		return CallNextHookEx(hHookWnd, nCode, wParam, lParam);
	}
	//b1,b2,b3,b4gāAύXƂ̂PostMessageȂǂ̍Hv͉\

	if (b1){
		GetClassName(p->hwnd, className, sizeof className);
		if (lstrcmp(className, _T("IME")) == 0 || lstrcmp(className, _T("GIMEJaUIWindow")) == 0
			|| lstrcmp(className, _T("Shell_TrayWnd")) == 0 || lstrcmp(className, _T("MSCTFIME UI")) == 0){
			return CallNextHookEx(hHookWnd, nCode, wParam, lParam);
		}
	}

	HIMC hIMC = ImmGetContext(p->hwnd);
	DWORD dwc, dws;
	ITfInputProcessorProfiles *pInputProcessorProfiles = NULL;
	ITfInputProcessorProfileMgr *pInputProcessorProfileMgr = NULL;
	HRESULT hr;
	//Ńk|肷ƑSẴvÔŒӂ
	hr = CoCreateInstance(CLSID_TF_InputProcessorProfiles, NULL, CLSCTX_INPROC_SERVER,
		IID_ITfInputProcessorProfiles, (LPVOID *)&pInputProcessorProfiles);
	if (hr == S_OK){
		hr = pInputProcessorProfiles->QueryInterface(
			IID_ITfInputProcessorProfileMgr, (LPVOID *)&pInputProcessorProfileMgr);
		if (hr != S_OK) pInputProcessorProfileMgr = NULL;
	}

	//TT_IME̎ws
	if (toDo & 1){
		if (hIMC){
			if (cMode < _CMODE_MAX){
				ImmSetOpenStatus(hIMC, TRUE);
				ImmGetConversionStatus(hIMC, &dwc, &dws);
				dwc = (dwc & ~(_CMODE_MAX - 1)) | cMode;
				ImmSetConversionStatus(hIMC, dwc, dws);
			} else {
				ImmSetOpenStatus(hIMC, FALSE);
			}
		}
	}
	if (toDo & 2){
		if (pInputProcessorProfileMgr){
			pInputProcessorProfileMgr->ActivateProfile(TF_PROFILETYPE_INPUTPROCESSOR,
				profile.langid, profile.clsid, profile.guidProfile, NULL, TF_IPPMF_FORPROCESS);
		} else {
			ActivateKeyboardLayout(hKL, 0);
		}
	}
	toDo = 0;

	//݂IMȄԂ𒲂ׂāATT_IME{̂փbZ[W𑗂
	DWORD wp;
	if (hIMC){
		if (ImmGetOpenStatus(hIMC)){
			ImmGetConversionStatus(hIMC, &dwc, &dws);
			wp = dwc & 0xf;
		} else {
			wp = _IME_CLOSED;
		}
		ImmReleaseContext(p->hwnd, hIMC);
	} else {
		wp = _IME_DISABLED;
	}
	
	LPARAM lp;
	hr = S_OK + 1;
	if (pInputProcessorProfileMgr){
		ZeroMemory(&profile, sizeof profile);
		hr = pInputProcessorProfileMgr->GetActiveProfile(GUID_TFCAT_TIP_KEYBOARD, &profile);
	} 
	if (hr == S_OK){
		lp = 0;
	} else {
		ZeroMemory(&profile, sizeof profile);
		lp = (LPARAM)GetKeyboardLayout(0);
	}
	if (pInputProcessorProfileMgr){
		pInputProcessorProfileMgr->Release();
		pInputProcessorProfiles->Release();
	}

	//wp = (WPARAM)p->hwnd;
	PostMessage(hWnd, WM_USERNOTIFY, wp, lp);

	return CallNextHookEx(hHookWnd, nCode, wParam, lParam);
}

void CALLBACK getprev(DWORD _toDo, DWORD _cMode, HKL _hKL)
{
	//TT_IMEϊ[hς
	toDo = _toDo;
	cMode = _cMode;
	hKL = _hKL;
	//j[ƁÃEBhEփtH[JX߂
	if (!hWnd_1) hWnd_1 = GetDesktopWindow();
	SetForegroundWindow(hWnd_1);
}

void CALLBACK sethook(HWND _hWnd, TF_INPUTPROCESSORPROFILE **p)
{
	*p = &profile;
	hWnd = _hWnd;
    hHookWnd = SetWindowsHookEx(WH_CALLWNDPROC, CallWndProc, hdll, 0);
}

void CALLBACK freehook()
{
    UnhookWindowsHookEx(hHookWnd);
}
