
#include "tt_ime.h"

LRESULT CALLBACK WindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
#ifndef _WIN64
	static NOTIFYICONDATA m_nIcon;
	static bool x64 = true;//ACRx64vZXIMEԂĂ邩
#endif
	static HICON hIcon[7];
	static HMENU hMenuOya, hMenu[2], hPopup;
	static HKL *phKL;
	static HWND hPrev;
	static int nKL;
	static int tempIcon, currIcon = 6, prevIcon = 6;
	static HKL tempHKL, currHKL;
	static TF_INPUTPROCESSORPROFILE currProfile, tempProfile;
	static std::vector<TF_INPUTPROCESSORPROFILE> vProfile;
	static CTSF *o;
	static UINT s_uTaskbarRestart;
	//ϊ[hƃACRCfbNXAݕϊe[u
	static const char c2i[16 + 2] = {
		4, 5, 5, 3, 5, 5, 5, 5, 2, 0, 5, 1, 5, 5, 5, 5,
		5, 6,
	};
	static const char i2c[5 + 2] = {
		IME_CMODE_FULLSHAPE | IME_CMODE_NATIVE,
		IME_CMODE_FULLSHAPE | IME_CMODE_NATIVE | IME_CMODE_KATAKANA,
		IME_CMODE_FULLSHAPE | IME_CMODE_ALPHANUMERIC,
		IME_CMODE_NATIVE | IME_CMODE_KATAKANA,
		IME_CMODE_ALPHANUMERIC,
		_IME_CLOSED,
		_IME_DISABLED,
	};

	switch (uMsg)
	{
	case WM_CREATE: {
		TCHAR c[256];
#ifndef _WIN64
		//64bitpN
		ShellExecute(NULL, _T("open"), _T("TT_IME_x64.exe"), _T("x64"), NULL, SW_SHOWNORMAL);
#endif

		//ݒ̓ǂݍ
		GetCurrentDirectory(sizeof ININAME, ININAME);
		lstrcat(ININAME, _T("\\TT_IME.ini"));
		for (int i = 0; i < iniNum; i++){
			if (i == 3){
				GetPrivateProfileString(_T("TT_IME"), iniName[i], _T("5"), c, sizeof c, ININAME);
			} else {
				GetPrivateProfileString(_T("TT_IME"), iniName[i], _T("0"), c, sizeof c, ININAME);
			}
			ini[i] = (char)_tcstoul(c, NULL, 10);
		}

		//IMEN
		hPrev = GetForegroundWindow();
		Sleep(50);
		if (ini[2]) Sleep(ini[3] * 1000);//ŏ҂
		SetForegroundWindow(hWnd);
#ifndef _WIN64
		if (ini[0]){
			HIMC hIMC = ImmGetContext(hWnd);
			ImmSetOpenStatus(hIMC, 1);
			ImmReleaseContext(hWnd, hIMC);
			keybd_event(0x41, 0, 0, 0);
		}
#endif

		//ENbNj[ƍNbNj[
		hMenuOya = LoadMenu((HINSTANCE)GetModuleHandle(0), MAKEINTRESOURCE(IDR_MENU1));
		hMenu[0] = GetSubMenu(hMenuOya, 0);
		hMenu[1] = GetSubMenu(hMenuOya, 1);

		//؂ւ̃|bvAbvj[
		hPopup = CreatePopupMenu();

		MENUITEMINFO mi;

		memset(&mi, 0, sizeof mi);
		mi.cbSize = sizeof mi;
		mi.fMask = MIIM_SUBMENU;
		mi.hSubMenu = hPopup;
		SetMenuItemInfo(hMenu[0], IDGENGO, FALSE, &mi);

#ifndef _WIN64
		//ACRǂݍ
		selectIconSet(hIcon, NULL);

		s_uTaskbarRestart = RegisterWindowMessage(_T("TaskbarCreated"));
#endif

		o = new CTSF;

		SetTimer(hWnd, 1, 0, NULL);
		break;
	}
	case WM_IME_SETCONTEXT:
		//IMEN邽߂TT_IME當͂ƂA
		//u͌Ă܂A߂ĕϊEBhE͌Ȃ悤ɂ
		lParam = 0;
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	case WM_TIMER:
		if (wParam == 1){
			KillTimer(hWnd, 1);

			SetForegroundWindow(hPrev);

#ifndef _WIN64
			m_nIcon.cbSize = sizeof m_nIcon;
			m_nIcon.uID = 1;
			m_nIcon.hWnd = hWnd;
			m_nIcon.uFlags = NIF_MESSAGE | NIF_ICON;
			m_nIcon.hIcon = hIcon[currIcon];
			m_nIcon.uCallbackMessage = WM_TRAY;
			Shell_NotifyIcon(NIM_ADD, &m_nIcon);

			startup();
#endif
			ImmDisableIME(-1);

		} else if (wParam == 2){
			KillTimer(hWnd, wParam);
#ifdef _WIN64
			COPYDATASTRUCT copyData;
			MYNOTIFYDATA data;

			currIcon = tempIcon;
			currProfile = tempProfile;
			currHKL = tempHKL;

			data.indexIcon = tempIcon;
			data.hKL = (UINT)tempHKL;
			ZeroMemory(&data.profile, sizeof data.profile);
			data.profile.dwProfileType = tempProfile.dwProfileType;
			data.profile.langid = tempProfile.langid;
			data.profile.clsid = tempProfile.clsid;
			data.profile.guidProfile = tempProfile.guidProfile;
			data.profile.catid = tempProfile.catid;
			data.profile.hklSubstitute = (_HKL32)tempProfile.hklSubstitute;
			data.profile.dwCaps = tempProfile.dwCaps;
			data.profile.hkl = (_HKL32)tempProfile.hkl;
			data.profile.dwFlags = tempProfile.dwFlags;

			copyData.cbData = sizeof data;
			copyData.dwData = 0;
			copyData.lpData = &data;
			SendMessage(FindWindow(CLASSNAME_x86, 0), WM_COPYDATA, (WPARAM)hWnd, (LPARAM)&copyData);
#else
			x64 = false;

		MODIFY_ICON:
			m_nIcon.uFlags = 0;

			if (currHKL != tempHKL || memcmp(&currProfile, &tempProfile, sizeof currProfile - DELTA) != 0){
				currProfile = tempProfile;
				currHKL = tempHKL;
				lstrcpy(m_nIcon.szTip, _T("Ȃ"));
				if (o->getState()){
					o->getDescription(&currProfile, m_nIcon.szTip, sizeof m_nIcon.szTip);
				} else {
					ImmGetDescription(currHKL, m_nIcon.szTip, sizeof m_nIcon.szTip);
				}
				selectIconSet(hIcon, m_nIcon.szTip);
				currIcon = -1;//selectIconSetɂăACR̃nhĂ邩Ȃ
				m_nIcon.uFlags |= NIF_TIP;
			}

			if (currIcon != tempIcon){
				currIcon = tempIcon;
				m_nIcon.hIcon = hIcon[currIcon];
				m_nIcon.uFlags |= NIF_ICON;
			}

			if (m_nIcon.uFlags){
				Shell_NotifyIcon(NIM_MODIFY, &m_nIcon);
			}
#endif
		}
		break;
#ifndef _WIN64
	case WM_COPYDATA: {
		x64 = true;
		MYNOTIFYDATA& data = *(MYNOTIFYDATA *)((PCOPYDATASTRUCT)lParam)->lpData;
		tempIcon = data.indexIcon;
		tempHKL = (HKL)data.hKL;
		memcpy(&tempProfile, &data.profile, sizeof tempProfile);
		goto MODIFY_ICON;
	}
#endif
	case WM_USERNOTIFY:
		//TCHAR c[256];
		//GetClassName((HWND)wParam, c, sizeof c);
		//printf("%S\n", c);
		if (0 <= wParam && wParam <= _IME_DISABLED){
			tempIcon = c2i[wParam];
		}
		tempHKL = (HKL)lParam;
		memcpy(&tempProfile, pProfile, sizeof tempProfile);
		SetTimer(hWnd, 2, 30, NULL);
		break;
	case WM_TRAY:
#ifndef _WIN64
		if (x64){
			HWND hWnd_x64 = FindWindow(CLASSNAME_x64, 0);
			SetForegroundWindow(hWnd_x64);
			SendMessage(hWnd_x64, uMsg, wParam, lParam);
			break;
		}
#endif
		switch (lParam)
		{
		case WM_LBUTTONUP:
		case WM_RBUTTONUP:
			POINT p;
			GetCursorPos(&p);
			SetForegroundWindow(hWnd);
			TrackPopupMenu((lParam == WM_RBUTTONUP) ? hMenu[0] : hMenu[1],
				TPM_LEFTALIGN | TPM_RIGHTBUTTON, p.x, p.y, 0, hWnd, NULL);
			PostMessage(hWnd, WM_NULL, 0, 0);
			break;
		}
		break;
#ifndef _WIN64
	case WM_GETTEXT:
		lstrcpy((TCHAR *)lParam, m_nIcon.szTip);
		break;
#endif
	case WM_INITMENUPOPUP: {
		TCHAR c[256];
		MENUITEMINFO mi;

		memset(&mi, 0, sizeof mi);
		mi.cbSize = sizeof mi;

		if ((HMENU)wParam == hMenu[1]){
			//ϊ[h̃`FbN
			if (prevIcon == currIcon) break;
			mi.fMask = MIIM_STATE;

			if (prevIcon < 6){
				mi.fState = 0;
				SetMenuItemInfo(hMenu[1], prevIcon, TRUE, &mi);
			}

			if (currIcon < 6){
				mi.fState = MFS_CHECKED;
				SetMenuItemInfo(hMenu[1], currIcon, TRUE, &mi);
			}

			prevIcon = currIcon;
		} else if ((HMENU)wParam == hPopup){
			//IĂ錾
			mi.fMask = MIIM_ID | MIIM_STATE | MIIM_TYPE;
			mi.fType = MFT_STRING | MFT_RADIOCHECK;
			mi.dwTypeData = c;
			while (DeleteMenu(hPopup, 0, MF_BYPOSITION));
			if (o->getState()){
				nKL = o->enumProfiles(&vProfile);
				for (int i = 0; i < nKL; i++){
					if (!o->getDescription(&vProfile[i], c, sizeof c)) continue;
					if (memcmp(&vProfile[i], &currProfile, sizeof currProfile - DELTA) == 0){
						mi.fState = MFS_CHECKED;
					} else {
						mi.fState = 0;
					}
					mi.wID = IDMENU + i;
					mi.cch = lstrlen(mi.dwTypeData);
					InsertMenuItem(hPopup, i, TRUE, &mi);
				}
			} else {
				nKL = GetKeyboardLayoutList(0, NULL);
				if (phKL) delete[] phKL;
				phKL = new HKL[nKL];
				nKL = GetKeyboardLayoutList(nKL, phKL);
				for (int i = 0; i < nKL; i++){
					if (!ImmGetDescription(phKL[i], c, sizeof c)) continue;
					if (phKL[i] == currHKL){
						mi.fState = MFS_CHECKED;
					} else {
						mi.fState = 0;
					}
					mi.wID = IDMENU + i;
					mi.cch = lstrlen(mi.dwTypeData);
					InsertMenuItem(hPopup, i, TRUE, &mi);
				}
			}
		} else if ((HMENU)wParam == hMenu[0]){
			mi.fMask = MIIM_ID | MIIM_TYPE;
			mi.fType = MFT_STRING;
			TCHAR *ac[5] = { _T("菑F"), _T("pbg"),
				_T("c[(&T)"), _T("Po^(&W)"), _T("vpeB(&P)") };
			char disp[5] = { 0, 0, 1, 0, 1 };
			int j = 0;
			for (int i = 0; i < 5; i++){
				DeleteMenu(hMenu[0], IDTEGAKI + i, MF_BYCOMMAND);
			}
			for (int i = 0; i < 5; i++){
				if (disp[i] || ini[1]){
					mi.wID = IDTEGAKI + i;
					mi.dwTypeData = ac[i];
					mi.cch = lstrlen(mi.dwTypeData);
					InsertMenuItem(hMenu[0], j++, TRUE, &mi);
				}
			}
		} else {
			break;
		}
		DrawMenuBar(hWnd);
		break;
	}
	case WM_COMMAND: {
		DWORD toDo = 0, cMode;
		HKL hKL;
		int k;
		BOOL ret;
		TCHAR path[MAX_PATH], *cmd;
		if (currProfile.dwProfileType == TF_PROFILETYPE_KEYBOARDLAYOUT){
			currHKL = currProfile.hkl;
		} else if (currProfile.hklSubstitute){
			currHKL = currProfile.hklSubstitute;
		}
		switch (LOWORD(wParam))
		{
		case IDTEGAKI://菑
			SHGetSpecialFolderPath(NULL, path, CSIDL_PROGRAM_FILESX86, FALSE);
			lstrcat(path, _T("\\Google\\Google Japanese Input\\GoogleIMEJaTool.exe"));
			ShellExecute(NULL, _T("open"), path, _T("--mode=hand_writing"), NULL, SW_SHOWNORMAL);
			break;
		case IDMOJI://pbg
			SHGetSpecialFolderPath(NULL, path, CSIDL_PROGRAM_FILESX86, FALSE);
			lstrcat(path, _T("\\Google\\Google Japanese Input\\GoogleIMEJaTool.exe"));
			ShellExecute(NULL, _T("open"), path, _T("--mode=character_palette"), NULL, SW_SHOWNORMAL);
			break;
		case IDJISHO://c[
			ret = ImmConfigureIME(currHKL, hWnd, IME_CONFIG_SELECTDICTIONARY, 0);
			if (!ret && getToolPath(path, &cmd, sizeof path, _T("JISHO"))){
				ShellExecute(NULL, _T("open"), path, cmd, NULL, SW_SHOWNORMAL);
			}
			break;
		case IDTANGO://Po^
			REGISTERWORD rw;
			rw.lpReading = _T("");
			rw.lpWord = _T("");
			ImmConfigureIME(currHKL, hWnd, IME_CONFIG_REGISTERWORD, &rw);
			break;
		case IDPROP://vpeB
			ret = ImmConfigureIME(currHKL, hWnd, IME_CONFIG_GENERAL, 0);
			if (!ret && getToolPath(path, &cmd, sizeof path, _T("PROP"))){
				ShellExecute(NULL, _T("open"), path, cmd, NULL, SW_SHOWNORMAL);
			}
			break;
		case IDSETTEI://ݒ
			lstrcpy(path, _T("shell32.dll,Control_RunDLL "));
			SHGetSpecialFolderPath(NULL, path + lstrlen(path), CSIDL_SYSTEM, FALSE);
			lstrcat(path, _T("\\input.dll"));
			ShellExecute(NULL, _T("open"), _T("RunDll32.exe"), path, NULL, SW_SHOWNORMAL);
			break;
		case IDTTIME://TT_IMẼvpeB
			DialogBox((HINSTANCE)GetModuleHandle(0), MAKEINTRESOURCE(IDD_DIALOG1), NULL, DlgProc);
			break;
		case IDCLOSE:
#ifdef _WIN64
			SendMessage(FindWindow(CLASSNAME_x86, 0), WM_CLOSE, 0, 0);
#else
			SendMessage(FindWindow(CLASSNAME_x64, 0), WM_CLOSE, 0, 0);
#endif
			DestroyWindow(hWnd);
			break;
		case IDCANCEL:
			break;
		default:
			//ϊ[h
			k = LOWORD(wParam) - IDHIRAGANA;//IDAĂƉ
			if (0 <= k && k < 6){
				cMode = i2c[k];
				toDo |= 1;
				break;
			}
			//؂ւ
			k = LOWORD(wParam) - IDMENU;
			if (0 <= k && k < nKL){
				if (phKL){
					hKL = phKL[k];
				} else {
					memcpy(pProfile, &vProfile[k], sizeof *pProfile);
				}
				toDo |= 2;
				break;
			}
		}
		getprev(toDo, cMode, hKL);
		break;
	}
	case WM_DESTROY:
#ifndef _WIN64
		Shell_NotifyIcon(NIM_DELETE, &m_nIcon);
		for (int i = 0; i < 7; i++){
			DestroyIcon(hIcon[i]);
		}
#endif
		delete o;
		delete[] phKL;
		DestroyMenu(hMenuOya);
		PostQuitMessage(0);
		break;
	default:
#ifndef _WIN64
		if (uMsg == s_uTaskbarRestart){
			if (ini[2]) Sleep(ini[3] * 1000);
			m_nIcon.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
			Shell_NotifyIcon(NIM_ADD, &m_nIcon);
			break;
		}
#endif
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nShowCmd)
{
#ifdef _WIN64
	const TCHAR *CLASSNAME = CLASSNAME_x64;
#else
	const TCHAR *CLASSNAME = CLASSNAME_x86;
#endif

	WNDCLASS wc;
	MSG msg;
	HWND hWnd;

	//ԈTT_IME_x64.exeNȂ悤
#ifdef _WIN64
	if (lstrcmp(lpCmdLine, _T("x64")) != 0){
		MessageBox(NULL, _T("TT_IME.exesĂB"), NULL, 0);
		return FALSE;
	}
#endif

	//dN֎~ł
	if (FindWindow(CLASSNAME, NULL)) return FALSE;

	//ǗҌƂAX̃vÕbZ[W󂯎悤
	myFilter();

//	//printffobOp
//	AllocConsole();
//	freopen("CONOUT$", "w", stdout);
//#ifdef _WIN64
//	printf("x64\n");
//#else
//	printf("x86\n");
//#endif

	wc.style		 = 0;
	wc.lpfnWndProc	 = WindowProc;
	wc.cbClsExtra	 = 0;
	wc.cbWndExtra	 = 0;
	wc.hInstance	 = hInstance;
	wc.hIcon		 = NULL;
	wc.hCursor		 = NULL;
	wc.hbrBackground = NULL;
	wc.lpszMenuName	 = NULL;
	wc.lpszClassName = CLASSNAME;
	if (!RegisterClass(&wc)) return 0;
	
	hWnd = CreateWindow(CLASSNAME, NULL, 0,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);
	if (hWnd == NULL) return 0;

	sethook(hWnd, &pProfile);
	BOOL bRet;
	while (bRet = GetMessage(&msg, NULL, 0, 0)){
		if (bRet == -1) break;
		DispatchMessage(&msg);
	}
	freehook();

	return (int)msg.wParam;
}
