
#include <windows.h>
#include <tchar.h>
#include <stdio.h>
#include <ShlObj.h>
#include <Msctf.h>
#include <vector>

#pragma comment(lib, "imm32.lib")

#include "resource.h"

#include "usermsg.h"

//x64x86ւ𑗂Ēʒm
typedef UINT _HKL32;
struct TF_INPUTPROCESSORPROFILE32 {
	DWORD dwProfileType;
	LANGID langid;
	CLSID clsid;
	GUID guidProfile;
	GUID catid;
	_HKL32 hklSubstitute;
	DWORD dwCaps;
	_HKL32 hkl;
	DWORD dwFlags;
};
struct MYNOTIFYDATA
{
	TF_INPUTPROCESSORPROFILE32 profile;
	int indexIcon;
	_HKL32 hKL;
};

TF_INPUTPROCESSORPROFILE *pipp = NULL;
const int DELTA = sizeof *pipp - ((char *)&pipp->dwFlags - (char *)pipp);

#ifdef _WIN64
#pragma comment(lib, "..\\x64\\Release\\IMEHook_x64.lib")
#else
#pragma comment(lib, "..\\Release\\IMEHook.lib")
#endif
extern void CALLBACK sethook(HWND, TF_INPUTPROCESSORPROFILE **);
extern void CALLBACK freehook();
extern void CALLBACK getprev(DWORD, DWORD, HKL);

const int IDMENU = 1000;//؂ւ̃j[

const TCHAR *CLASSNAME_x86 = _T("TT_IME_x86");
const TCHAR *CLASSNAME_x64 = _T("TT_IME_x64");
TF_INPUTPROCESSORPROFILE *pProfile;

//init@C
TCHAR ININAME[MAX_PATH];
const DWORD iniNum = 4;
const TCHAR *iniName[iniNum] = {_T("IMEStart"), _T("AdditionalMenu"), _T("Delay"), _T("DelaySec")};
char ini[iniNum];

INT_PTR CALLBACK DlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	DWORD k;
	HWND hUpdown;
	switch (uMsg)
	{
	case WM_INITDIALOG:
		CheckDlgButton(hDlg, IDC_CHECK1, ini[0]);
		CheckDlgButton(hDlg, IDC_CHECK2, ini[1]);
		CheckDlgButton(hDlg, IDC_CHECK3, ini[2]);
		hUpdown = GetDlgItem(hDlg, IDC_SPIN1);
		SendMessage(hUpdown, UDM_SETRANGE, 0, MAKELONG(180, 0));
		SendMessage(hUpdown, UDM_SETPOS, 0, ini[3]);
		PostMessage(hDlg, WM_COMMAND, IDC_CHECK3, 0);
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
			ini[0] = IsDlgButtonChecked(hDlg, IDC_CHECK1);
			ini[1] = IsDlgButtonChecked(hDlg, IDC_CHECK2);
			ini[2] = IsDlgButtonChecked(hDlg, IDC_CHECK3);
			k = ini[2];
			EnableWindow(GetDlgItem(hDlg, IDC_SPIN1), k);
			EnableWindow(GetDlgItem(hDlg, IDC_EDIT1), k);
			EnableWindow(GetDlgItem(hDlg, IDC_STATIC1), k);
			hUpdown = GetDlgItem(hDlg, IDC_SPIN1);
			ini[3] = (char)SendMessage(hUpdown, UDM_GETPOS, 0, 0);
			TCHAR c[64];
			for (int i = 0; i < iniNum; i++){
				wsprintf(c, _T("%d"), ini[i]);
				WritePrivateProfileString(_T("TT_IME"), iniName[i], c, ININAME);
			}
		case IDCANCEL:
			EndDialog(hDlg, 0);
			break;
		case IDC_CHECK3:
			k = IsDlgButtonChecked(hDlg, IDC_CHECK3);
			EnableWindow(GetDlgItem(hDlg, IDC_SPIN1), k);
			EnableWindow(GetDlgItem(hDlg, IDC_EDIT1), k);
			EnableWindow(GetDlgItem(hDlg, IDC_STATIC1), k);
			break;
		default:
			return FALSE;
		}
		break;
	case WM_CLOSE:
		EndDialog(hDlg, 0);
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

//TSF̏܂Ƃ߂Ăi悭킩Ȃj
class CTSF
{
	ITfInputProcessorProfiles *pInputProcessorProfiles;
	ITfInputProcessorProfileMgr *pInputProcessorProfileMgr;
	int state;

public:
	int getState(){
		return state;
	}
	int enumProfiles(std::vector<TF_INPUTPROCESSORPROFILE> *vProfile)
	{
		if (!state) return 0;
		IEnumTfInputProcessorProfiles *pEnumInputProcessorProfiles = NULL;
		TF_INPUTPROCESSORPROFILE profile;
		HRESULT hr;

		hr = pInputProcessorProfileMgr->EnumProfiles(1041, &pEnumInputProcessorProfiles);
		if (hr != S_OK) return 0;

		ZeroMemory(&profile, sizeof profile);
		vProfile->clear();
		while (pEnumInputProcessorProfiles->Next(1, &profile, NULL) == S_OK){
			vProfile->push_back(profile);
			ZeroMemory(&profile, sizeof(TF_INPUTPROCESSORPROFILE));
		}
		pEnumInputProcessorProfiles->Release();
		return (int)vProfile->size();
	}
	int getDescription(TF_INPUTPROCESSORPROFILE *_pProfile, LPTSTR lpszDescription, UINT uBufLen)
	{
		if (!state) return 0;
		if (_pProfile->dwProfileType == TF_PROFILETYPE_INPUTPROCESSOR &&
			_pProfile->catid == GUID_TFCAT_TIP_KEYBOARD){
			// TSF
			BSTR bstrProfile = NULL;
			pInputProcessorProfiles->GetLanguageProfileDescription(
				_pProfile->clsid, _pProfile->langid, _pProfile->guidProfile, &bstrProfile);
#ifdef UNICODE
			lstrcpyn(lpszDescription, (LPWSTR)bstrProfile, uBufLen);
#else
			WideCharToMultiByte(CP_ACP, 0, bstrProfile, -1, lpszDescription, uBufLen * sizeof(char), NULL, NULL);
#endif
			SysFreeString(bstrProfile);
			return 1;
		} else if (_pProfile->dwProfileType == TF_PROFILETYPE_KEYBOARDLAYOUT &&
			!(_pProfile->dwFlags & TF_IPP_FLAG_SUBSTITUTEDBYINPUTPROCESSOR)){
			// Keybord layout
			return ImmGetDescription(_pProfile->hkl, lpszDescription, uBufLen);
		} else {
			return 0;
		}
	}
	CTSF(){
		state = 0;
		pInputProcessorProfiles = NULL;
		pInputProcessorProfileMgr = NULL;
		HRESULT hr;
		hr = CoCreateInstance(CLSID_TF_InputProcessorProfiles, NULL, CLSCTX_INPROC_SERVER,
			IID_ITfInputProcessorProfiles, (LPVOID *)&pInputProcessorProfiles);
		if (hr != S_OK) return;
		hr = pInputProcessorProfiles->QueryInterface(
			IID_ITfInputProcessorProfileMgr, (LPVOID *)&pInputProcessorProfileMgr);
		if (hr != S_OK){
			pInputProcessorProfiles->Release();
			return;
		}
		state = 1;
	}
	~CTSF(){
		if (state){
			pInputProcessorProfileMgr->Release();
			pInputProcessorProfiles->Release();
		}
	}
};

//茠̒ႢvÕbZ[W󂯎
void myFilter(){
	typedef BOOL (WINAPI *FUNCTYPE)(UINT message, DWORD dwFlag);
	FUNCTYPE _ChangeWindowMessageFilter;
	HMODULE hdll = LoadLibrary(_T("user32.dll"));
	_ChangeWindowMessageFilter =
		(FUNCTYPE)GetProcAddress(LoadLibrary(_T("user32.dll")), "ChangeWindowMessageFilter");
	if (_ChangeWindowMessageFilter){
		_ChangeWindowMessageFilter(WM_USERNOTIFY, MSGFLT_ADD);
	}
	FreeLibrary(hdll);
}

//StartuptH_̒gs
void startup(){
	WIN32_FIND_DATA fd;
	HANDLE hFind;
	TCHAR c[MAX_PATH], path[MAX_PATH];
	
	GetCurrentDirectory(sizeof path, path);
	lstrcat(path, _T("\\Startup"));

	hFind = FindFirstFile(path, &fd);
	if (hFind == INVALID_HANDLE_VALUE) return;
	FindClose(hFind);
	if (!(fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) return;
	
	lstrcpy(c, path);
	lstrcat(c, _T("\\*.*"));
	hFind = FindFirstFile(c, &fd);
	if (hFind == INVALID_HANDLE_VALUE) return;
	do {
		if (fd.dwFileAttributes & (FILE_ATTRIBUTE_DIRECTORY | FILE_ATTRIBUTE_SYSTEM)) continue;
		wsprintf(c, _T("%s\\%s"), path, fd.cFileName);
		ShellExecute(NULL, NULL, c, NULL, NULL, SW_SHOWNORMAL);
	} while (FindNextFile(hFind, &fd));
	FindClose(hFind);
}

int getToolPath(TCHAR *path, TCHAR **cmd, int nSize, TCHAR *type){
	TCHAR c[MAX_PATH], ime[128];
	GetCurrentDirectory(sizeof c, c);
	lstrcat(c, _T("\\Override.ini"));
	SendMessage(FindWindow(CLASSNAME_x86, 0), WM_GETTEXT, (WPARAM)sizeof ime, (LPARAM)ime);
	int k = GetPrivateProfileString(ime, type, _T(""), path, nSize, c);
	if (k == 0) return 0;

	TCHAR *p = path;
	*cmd = NULL;
	for (int m = 0; *p; p++){
		if (m == 0){
			if (*p == ' '){
				*p = 0;
				*cmd = p + 1;
				break;
			}
			if (*p == '")') m = 1;
		} else {
			if (*p == '")') m = 0;
		}
	}
	return k;
}

int dirExists(TCHAR *dir){
	WIN32_FIND_DATA fd;
	HANDLE hFind;
	if (!dir) return 0;
	hFind = FindFirstFile(dir, &fd);
	if (hFind == INVALID_HANDLE_VALUE) return 0;
	FindClose(hFind);
	return fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY;
}

void selectIconSet(HICON *hIcon, TCHAR *ime){
	TCHAR c[MAX_PATH], dir[MAX_PATH];
	if (dirExists(ime)){
		wsprintf(dir, _T("%s\\"), ime);
	} else {
		*dir = 0;
	}
	for (int i = 0; i < 7; i++){
		if (hIcon[i]){
			DestroyIcon(hIcon[i]);
			hIcon[i] = NULL;
		}
		wsprintf(c, _T("%sicon%d.ico"), dir, i + 1);
		ExtractIconEx(c, 0, NULL, &hIcon[i], 1);
	}
}
